## glib2.0 2.62.1

=== debian/changelog ===
glib2.0 (2.62.1-1) unstable; urgency=medium

  * Team upload
  * d/watch: Only watch for even-numbered (stable) releases
  * New upstream release
    - Fix regression that made G_FILE_COPY_TARGET_DEFAULT_PERMS result in
      private permissions rather than respecting umask (Closes: #505398)
    - d/p/g_file_info_get_modification_date_time-Calculate-in-integ.patch,
      d/p/Always-build-tests-if-we-enabled-installed-tests.patch:
      Drop patches that were applied upstream
  * d/p/debian/mimeapps-test-Mark-as-flaky.patch:
    Mark mimeapps test as flaky (see #941550)

 -- Simon McVittie <smcv@debian.org>  Mon, 07 Oct 2019 09:46:24 +0100

glib2.0 (2.62.0-3) unstable; urgency=medium

  * Team upload
  * Merge packaging from 2.60.x branch previously in unstable
    - No changes since 2.62.0-2, except in d/changelog
    - d/p/debian/Disable-an-optimization-when-building-with-gcc-9.patch:
      Remove workaround for #931921, which turned out to be a clutter bug
  * d/p/Always-build-tests-if-we-enabled-installed-tests.patch:
    Add patch to fix installation of installed-tests in cross-builds
    (Closes: #941509)
  * d/p/g_file_info_get_modification_date_time-Calculate-in-integ.patch:
    Add patch to fix intermittent g-file-info test failures on i386
    (Closes: #941547)
  * libglib2.0-dev: Suggest libgirepository1.0-dev, for the GIR files
    (Closes: #914152)
  * d/gbp.conf: Use debian/master branch
  * Standards-Version: 4.4.1 (no changes required)

 -- Simon McVittie <smcv@debian.org>  Wed, 02 Oct 2019 09:13:12 +0100

glib2.0 (2.60.6-2) unstable; urgency=medium

  * Team upload
  * d/rules: Edit debcrossgen output instead of using a modified version.
    This fixes use of CFLAGS, etc. during cross-compilation.
    (Closes: #933560)
  * Remove obsolete permissions fixing.
    Issue 1539 was fixed upstream.
  * d/p/debian/Disable-an-optimization-when-building-with-gcc-9.patch:
    Disable an optimization when building with gcc-9, instead of forcing
    gcc-8. This avoids depending on an old gcc, and should be easier to
    deal with for cross-compilation. (Workaround for #931921)
  * d/p/gmessages-Only-use-structured-logs-if-GLIB_VERSION_MAX_AL.patch:
    Update to upstream glib-2-60 branch at commit 2.60.6-2-ga365528f6
    - Don't use structured logging if GLIB_VERSION_MAX_ALLOWED < 2.56

 -- Simon McVittie <smcv@debian.org>  Tue, 13 Aug 2019 10:32:40 +0100

glib2.0 (2.62.0-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable. (Closes: #940161)

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 30 Sep 2019 12:33:16 +0200

glib2.0 (2.62.0-1) experimental; urgency=medium

  * New upstream release
    + Fix new `GFileInfo` APIs to work when
      `G_FILE_ATTRIBUTE_TIME_MODIFIED_USEC` was not queried

 -- Iain Lane <laney@debian.org>  Mon, 09 Sep 2019 15:41:48 +0100

glib2.0 (2.61.3-1) experimental; urgency=medium

  * New upstream release
  * d/p: Drop cherry-picks from upstream branch which we now have
  * d/p/d/Disable-an-optimization-when-building-with-gcc-9.patch: Drop,
    clutter has been fixed now (thanks Simon)
  * d/p/*: Refresh via gbp-pq as necessary

 -- Iain Lane <laney@debian.org>  Wed, 04 Sep 2019 17:29:23 +0100

glib2.0 (2.61.2-2) experimental; urgency=medium

  * Team upload
  * d/p/cond-test-Don-t-make-assumptions-about-struct-sigaction-m.patch:
    Add proposed patch to fix FTBFS due to a test failure on mips*

 -- Simon McVittie <smcv@debian.org>  Tue, 13 Aug 2019 10:29:29 +0100

glib2.0 (2.61.2-1) experimental; urgency=medium

  * Team upload
  * New upstream release
  * d/patches: Update to upstream git master, commit 2.61.2-23-g870b30bd7
    - Fix regression in g_mkdir_with_permissions()
    - Fix a memory leak
    - Update translations: es, id, ro
  * Merge changes from unstable
  * Refresh patch series
  * d/p/debian/06_thread_test_ignore_prctl_fail.patch:
    Use g_test_skip() when skipping test
  * d/p/GIO-tests-Don-t-do-clever-tricks-with-objcopy.patch:
    Drop workaround for #932287, and build-depend on fixed binutils on
    mips64el instead
  * d/rules: Edit debcrossgen output instead of using a modified version.
    This fixes use of CFLAGS, etc. during cross-compilation.
    (Closes: #933560)
  * d/libglib2.0-0.symbols: Update
  * Remove obsolete permissions fixing.
    Issue 1539 was fixed upstream.
  * libglib2.0-tests: Depend on libglib2.0-dev-bin.
    This is required for the new mkenums and genmarshal tests.
  * d/p/debian/Disable-an-optimization-when-building-with-gcc-9.patch:
    Disable an optimization when building with gcc-9, instead of forcing
    gcc-8. This avoids depending on an old gcc, and should be easier to
    deal with for cross-compilation. (Workaround for #931921)

 -- Simon McVittie <smcv@debian.org>  Mon, 12 Aug 2019 09:32:26 +0100

glib2.0 (2.60.6-1) unstable; urgency=medium

  * Team upload
  * New upstream release, functionally equivalent to 2.60.5 with the
    patches we were already applying
    - d/p/portal-Add-a-getter-for-dconf-access.patch,
      d/p/settings-Tweak-priorities-for-keyfile-backend.patch,
      d/p/key-file-Handle-filename-being-NULL.patch:
      Drop, applied upstream
  * d/p/tests-Fix-data-race-in-gmenumodel-test.patch,
    d/p/tests-Fix-data-race-in-task-test.patch:
    Add patches from upstream git master to fix data races in tests.
    In particular, the one for gmenumodel might solve an unreproducible
    test failure on i386 (see #932678).
  * d/p/debian/gmenumodel-test-Mark-as-flaky.patch,
    d/p/debian/gvariant-test-Don-t-run-at-build-time-on-mips.patch:
    Skip more tests at build-time and during the non-flaky autopkgtest.
    The unreproducible gmenumodel test failure on i386 might in fact be
    fixed by d/p/tests-Fix-data-race-in-gmenumodel-test.patch, but it's
    hard to be sure about that. The gvariant fuzz test is catastrophically
    slow on certain mips CPUs and so is impractical to run there.
    (Closes: #932678)
  * Standards-Version: 4.4.0 (no changes required)


=== debian/control ===
# This file is autogenerated. DO NOT EDIT!
#
# Modifications should be made to debian/control.in instead.
# This file is regenerated automatically in the clean target.
Source: glib2.0
Section: libs
Priority: optional
Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
Uploaders: Iain Lane <laney@debian.org>
Build-Depends: dbus <!nocheck>,
               debhelper-compat (= 12),
               desktop-file-utils <!nocheck>,
               dh-exec,
               dh-python,
               docbook-xml,
               docbook-xsl,
               dpkg-dev (>= 1.17.14),
               gettext,
               gnome-pkg-tools (>= 0.11),
               gtk-doc-tools (>= 1.20),
               libelf-dev (>= 0.142),
               libffi-dev (>= 3.0.0),
               libgamin-dev [!linux-any] | libfam-dev [!linux-any],
               libmount-dev (>= 2.28) [linux-any],
               libpcre3-dev (>= 1:8.35),
               libselinux1-dev [linux-any],
               libxml2-utils,
               linux-libc-dev [linux-any],
               meson (>= 0.48.0),
               pkg-config (>= 0.16.0),
               python3-dbus <!nocheck>,
               python3-distutils,
               python3-gi <!nocheck>,
               python3:any (>= 2.7.5-5~),
               shared-mime-info <!nocheck>,
               tzdata <!nocheck>,
               xsltproc,
               xterm <!nocheck>,
               zlib1g-dev
Rules-Requires-Root: no
Standards-Version: 4.4.1
Homepage: http://www.gtk.org/
Vcs-Browser: https://salsa.debian.org/gnome-team/glib/tree/debian/experimental
Vcs-Git: https://salsa.debian.org/gnome-team/glib.git -b debian/experimental

Package: libglib2.0-0
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: libglib2.0-data,
            shared-mime-info,
            xdg-user-dirs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: GLib library of C routines
 GLib is a library containing many useful C routines for things such
 as trees, hashes, lists, and strings.  It is a useful general-purpose
 C library used by projects such as GTK+, GIMP, and GNOME.
 .
 This package contains the shared libraries.

Package: libglib2.0-tests
Architecture: any
Depends: libglib2.0-dev-bin,
         shared-mime-info,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: GLib library of C routines - installed tests
 GLib is a library containing many useful C routines for things such
 as trees, hashes, lists, and strings.  It is a useful general-purpose
 C library used by projects such as GTK+, GIMP, and GNOME.
 .
 This package contains test programs, designed to be run as part of a
 regression testsuite.

Package: libglib2.0-udeb
Build-Profiles: <!noudeb>
Section: debian-installer
Package-Type: udeb
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: GLib library of C routines - minimal runtime
 This is a udeb, or a microdeb, for the debian-installer.
 .
 GLib is a library containing many useful C routines for things such
 as trees, hashes, lists, and strings.  It is a useful general-purpose
 C library used by projects such as GTK+, GIMP, and GNOME.
 .
 This package contains the minimal runtime library needed by the Debian
 installer.

Package: libglib2.0-bin
Section: misc
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libglib2.0-0 (= ${binary:Version}),
         libglib2.0-data,
         ${misc:Depends},
         ${shlibs:Depends}
Multi-Arch: foreign
Description: Programs for the GLib library
 GLib is a library containing many useful C routines for things such
 as trees, hashes, lists, and strings.  It is a useful general-purpose
 C library used by projects such as GTK+, GIMP, and GNOME.
 .
 This package contains the program files which is used for the libraries
 and others.

Package: libglib2.0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libffi-dev (>= 3.0.0),
         libglib2.0-0 (= ${binary:Version}),
         libglib2.0-bin (= ${binary:Version}),
         libglib2.0-dev-bin (= ${binary:Version}),
         libmount-dev (>= 2.28) [linux-any],
         libpcre3-dev (>= 1:8.31),
         libselinux1-dev [linux-any],
         pkg-config,
         zlib1g-dev,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Breaks: libglib2.0-0-dbg (<< 2.51.4-1~)
Replaces: libglib2.0-0-dbg (<< 2.51.4-1~)
Suggests: libgirepository1.0-dev (>= 1.62),
          libglib2.0-doc
Description: Development files for the GLib library
 GLib is a library containing many useful C routines for things such
 as trees, hashes, lists, and strings.  It is a useful general-purpose
 C library used by projects such as GTK+, GIMP, and GNOME.
 .
 This package is needed to compile programs against libglib2.0-0,
 as only it includes the header files and static libraries (optionally)
 needed for compiling.
 .
 GObject-Introspection metadata for this library can be found in the
 libgirepository1.0-dev package.

Package: libglib2.0-dev-bin
Section: libdevel
Architecture: any
Depends: python3-distutils,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: libgdk-pixbuf2.0-bin (>= 2.36.12-2~) | libgdk-pixbuf2.0-dev,
          libxml2-utils
Breaks: libglib2.0-bin (<< 2.54.2-5~),
        libglib2.0-dev (<< 2.53)
Replaces: libglib2.0-bin (<< 2.54.2-5~),
          libglib2.0-dev (<< 2.53)
Multi-Arch: foreign
Description: Development utilities for the GLib library
 GLib is a library containing many useful C routines for things such
 as trees, hashes, lists, and strings.  It is a useful general-purpose
 C library used by projects such as GTK+, GIMP, and GNOME.
 .
 This package is needed to compile programs against libglib2.0-0. It contains
 development utilities typically run during compilation and should not be
 installed directly. Use libglib2.0-dev instead.

Package: libglib2.0-data
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Common files for GLib library
 GLib is a library containing many useful C routines for things such
 as trees, hashes, lists, and strings.  It is a useful general-purpose
 C library used by projects such as GTK+, GIMP, and GNOME.
 .
 This package is needed for the runtime libraries to display messages in
 languages other than English.

Package: libglib2.0-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: devhelp
Multi-Arch: foreign
Description: Documentation files for the GLib library
 GLib is a library containing many useful C routines for things such
 as trees, hashes, lists, and strings.  It is a useful general-purpose
 C library used by projects such as GTK+, GIMP, and GNOME.
 .
 This package contains the HTML documentation for the GLib library
 in /usr/share/doc/libglib2.0-doc/ .

Package: libgio-fam
Architecture: hurd-any kfreebsd-any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: gamin
Multi-Arch: same
Description: GLib Input, Output and Streaming Library (fam module)
 GIO is the input, output and streaming API of GLib. This package
 provides a fam file and directory monitoring backend for it.

## glib2.0 2.62.4

=== debian/changelog ===
glib2.0 (2.62.4-1~ubuntu19.10.1) eoan; urgency=medium

  * No-change backport from unstable to eoan (LP: #1850932).
    + Contains fix for LP: #1844853 - "IBus no longer works in Qt applications
      after upgrade"

 -- Iain Lane <iain@orangesquash.org.uk>  Wed, 05 Feb 2020 16:43:07 +0000

glib2.0 (2.62.4-1) unstable; urgency=medium

  * Team upload

  [ Steve Langasek ]
  * debian/tests/build: Make cross-test friendly (Closes: #946355)

  [ Iain Lane ]
  * debian/tests/build: Style fixes

  [ Simon McVittie ]
  * New upstream release

 -- Simon McVittie <smcv@debian.org>  Mon, 30 Dec 2019 13:01:04 +0000

glib2.0 (2.62.3-2) unstable; urgency=medium

  * Team upload
  * Rename pkg.glib2.0.noinsttest build profile to noinsttest.
    This is now registered on <https://wiki.debian.org/BuildProfileSpec>.

 -- Simon McVittie <smcv@debian.org>  Sun, 01 Dec 2019 16:05:01 +0000

glib2.0 (2.62.3-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    - Drop patches that were applied upstream
  * Don't build libglib2.0-tests under pkg.glib2.0.noinsttest build profile.
    This is a prototype of the proposed standard build profile noinsttest.
    If the build profiles include both nocheck and pkg.glib2.0.noinsttest,
    we can drop the libdbus-1-dev build-dependency without harming test
    coverage or altering the contents of binary packages.
  * d/gbp.conf: Use upstream/2.62.x branch

 -- Simon McVittie <smcv@debian.org>  Mon, 25 Nov 2019 08:47:58 +0000

glib2.0 (2.62.2-3) unstable; urgency=medium

  * Team upload

  [ Iain Lane ]
  * control: Drop `debian/experimental` from Vcs-*

  [ Simon McVittie ]
  * Build-depend on libdbus-1-dev for better test coverage
  * Update to upstream commit 2.62.2-28-g3cf25070e:
    - d/p/goption-Relax-assertion-to-avoid-being-broken-by-kdeinit5.patch:
      Fix assertion failure when called from a process that overwrites its
      argv, such as kdeinit5
    - d/p/gdbus-peer-Specifically-listen-on-127.0.0.1.patch:
      Improve reliability of gdbus-peer test in some container environments
    - d/p/gdbusserver-Delete-socket-and-nonce-file-when-stopping-se.patch,
      d/p/gdbusserver-Keep-a-strong-reference-to-the-server-in-call.patch,
      d/p/gdbusauthmechanismsha1-Remove-unnecessary-g_warning-calls.patch,
      d/p/gdbusauthmechanismsha1-Create-.dbus-keyrings-directory-re.patch,
      d/p/tests-Move-main-loop-and-test-GUID-into-test-functions-in.patch,
      d/p/tests-Isolate-directories-in-gdbus-peer-test.patch,
      d/p/gdbus-peer-test-Improve-diagnostics-if-g_rmdir-fails.patch,
      d/p/gdbus-peer-test-Stop-GDBusServer-before-tearing-down-temp.patch,
      d/p/gdbus-peer-test-Use-unix-dir-address-if-exact-format-does.patch,
      d/p/gdbus-server-auth-test-Create-temporary-directory-for-Uni.patch:
      Mark as applied upstream in 2.62.x branch
  * d/p/gdbus-server-auth-test-Include-gcredentialsprivate.h.patch:
    Apply patch from 2.63.x to fix missing coverage in test for #941018
  * d/p/Make-ld-executable-configurable.patch:
    Apply patch from 2.63.x to use cross ld where necessary
  * d/p/gdbus-server-auth-test-Create-temporary-directory-for-Uni.patch:
    Mark as applied upstream in 2.63.x branch
  * Improve patch metadata: use more URLs for bug references

 -- Simon McVittie <smcv@debian.org>  Wed, 06 Nov 2019 09:02:14 +0000

glib2.0 (2.62.2-2) unstable; urgency=medium

  * Team upload
  * Update to upstream commit 2.62.2-14-gfcbb88823:
    - d/p/gdesktopappinfo-Allocate-DesktopFileDir-structs-dynamical.patch,
      d/p/gdesktopappinfo-Cancel-file-monitor-when-resetting-a-Desk.patch,
      d/p/glocalfilemonitor-Keep-a-weak-ref-to-the-monitor-in-GFile.patch:
      Fix intermittent test failures for GDesktopAppInfo (Closes: #941550)
    - d/p/gvariant-Limit-recursion-in-g_variant_parse.patch:
      Ensure that parsing a text-format GVariant does not run out of stack
      space
    - d/p/tests-Use-objcopy-from-the-cross-compilation-file-if-conf.patch,
      d/p/docs-Add-objcopy-to-example-cross-compilation-file.patch:
      Use the appropriate architecture's objcopy when cross-compiling
    - d/p/gtestutils-Add-additional-non-NULL-check-in-g_assert_cmpm.patch:
      Avoid false positive NULL dereference warnings in g_assert_cmpmem()
    - d/p/gspawn-Port-to-g_poll-from-select.patch:
      Fix launching subprocesses when a very large number of fds are open
    - d/p/gcredentialsprivate-Document-the-various-private-macros.patch,
      d/p/credentials-Invalid-Linux-struct-ucred-means-no-informati.patch,
      d/p/GDBus-prefer-getsockopt-style-credentials-passing-APIs.patch:
      Ensure libdbus clients can authenticate with a GDBusServer like the
      one in ibus (Closes: #941018)
  * d/p/gdbusserver-Delete-socket-and-nonce-file-when-stopping-se.patch,
    d/p/gdbusserver-Keep-a-strong-reference-to-the-server-in-call.patch,
    d/p/Add-a-test-for-GDBusServer-authentication.patch:
    Backport regression test for #941018 from upstream git master
  * d/p/gdbusauthmechanismsha1-Remove-unnecessary-g_warning-calls.patch,
    d/p/gdbusauthmechanismsha1-Create-.dbus-keyrings-directory-re.patch,
    d/p/tests-Move-main-loop-and-test-GUID-into-test-functions-in.patch,
    d/p/tests-Isolate-directories-in-gdbus-peer-test.patch:
    Backport reliability fixes for gdbus-peer test from upstream git master
  * d/p/gdbus-peer-test-Improve-diagnostics-if-g_rmdir-fails.patch,
    d/p/gdbus-peer-test-Stop-GDBusServer-before-tearing-down-temp.patch,
    d/p/gdbus-peer-test-Use-unix-dir-address-if-exact-format-does.patch,
    d/p/gdbus-server-auth-test-Create-temporary-directory-for-Uni.patch:
    Add some proposed patches to improve GDBus unit tests
  * d/p/debian/mimeapps-test-Mark-as-flaky.patch:
    Drop patch, hopefully no longer needed with #941550 fixed
  * d/p/debian/taptestrunner-Stop-looking-like-an-executable-script.patch:
    Make taptestrunner non-executable to avoid a Lintian warning



=== debian/control ===
--- 
+++ 
@@ -18,6 +18,7 @@
                gettext,
                gnome-pkg-tools (>= 0.11),
                gtk-doc-tools (>= 1.20),
+               libdbus-1-dev (>= 1.2.14) <!nocheck> <!noinsttest>,
                libelf-dev (>= 0.142),
                libffi-dev (>= 3.0.0),
                libgamin-dev [!linux-any] | libfam-dev [!linux-any],
@@ -40,8 +41,8 @@
 Rules-Requires-Root: no
 Standards-Version: 4.4.1
 Homepage: http://www.gtk.org/
-Vcs-Browser: https://salsa.debian.org/gnome-team/glib/tree/debian/experimental
-Vcs-Git: https://salsa.debian.org/gnome-team/glib.git -b debian/experimental
+Vcs-Browser: https://salsa.debian.org/gnome-team/glib
+Vcs-Git: https://salsa.debian.org/gnome-team/glib.git
 
 Package: libglib2.0-0
 Architecture: any
@@ -60,6 +61,7 @@
  This package contains the shared libraries.
 
 Package: libglib2.0-tests
+Build-profiles: <!noinsttest>
 Architecture: any
 Depends: libglib2.0-dev-bin,
          shared-mime-info,

=== debian/rules ===
#!/usr/bin/make -f

binaries := $(shell dh_listpackages)

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

# Ensure the build aborts when there are still references to undefined symbols
DEB_LDFLAGS_MAINT_APPEND += -Wl,-z,defs

# NB: do NOT use -Wl,--as-needed to build glib; for instance the link to
# pthread is carefully crafted to allow dlopen()ing pthread-using libs; see
# http://mid.gmane.org/1257999019.21780.15.camel@marzipan
DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed

# Make the linker work a bit harder so dynamic loading can be done faster
DEB_LDFLAGS_MAINT_APPEND += -Wl,-O1

include /usr/share/dpkg/default.mk

%:
	dh $@ --with gnome,python3 --buildsystem=meson

override_dh_autoreconf:
	@:

ifneq ($(filter hppa,$(DEB_HOST_ARCH_CPU)),)
stack_grows_up = true
else
stack_grows_up = false
endif

ifneq ($(filter kfreebsd,$(DEB_HOST_ARCH_OS)),)
have_non_stub_xattr = false
else
have_non_stub_xattr = true
endif

export DH_MESON_CROSS_FILE = debian/cross.txt

# We edit the debcrossgen output to work around unimplemented feature
# request https://bugs.debian.org/912559
override_dh_auto_configure:
ifneq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
	/usr/share/meson/debcrossgen \
		-o debian/cross.txt.in
	debian/set-cross-properties \
		have_c99_snprintf=true \
		have_c99_vsnprintf=true \
		have_strlcpy=false \
		have_unix98_printf=true \
		growing_stack=$(stack_grows_up) \
		< debian/cross.txt.in > debian/cross.txt
endif
	dh_auto_configure \
		--builddirectory=debian/build/deb \
		-- \
		$(DEB_CONFIGURE_EXTRA_FLAGS) \
		$(DEB_CONFIGURE_FLAGS_deb) \
		$(NULL)
ifneq ($(filter %-udeb,$(binaries)),)
	dh_auto_configure \
		--builddirectory=debian/build/udeb \
		-- \
		$(DEB_CONFIGURE_EXTRA_FLAGS) \
		$(DEB_CONFIGURE_FLAGS_udeb) \
		$(NULL)
endif

override_dh_clean:
	rm -rf $(CURDIR)/debian/build \
	       $(CURDIR)/debian/install \
	       $(CURDIR)/debian/tmp-xdg-runtime-dir
	dh_clean -Xorg.gtk.test.gschema.xml.orig -Xorg.gtk.test.gschema.override.orig


override_dh_makeshlibs:
	dh_makeshlibs -plibglib2.0-tests -n
	dh_makeshlibs --remaining-packages --add-udeb=libglib2.0-udeb -- -c4

override_dh_strip:
	dh_strip --dbgsym-migration='libglib2.0-0-dbg (<< 2.51.4-1~)'

# (Ubuntu-specific)
# Don't strip translations from the installed tests; makes them environment dependent.
override_dh_translations:
	dh_translations -Xinstalled-tests

# Do not clutter $HOME with ~/.dbus-keyrings and avoid failure on the buildds
# where creating /home/buildd/.dbus-keyrings fails
export HOME=$(CURDIR)/debian/build

# Put these back to their defaults if we are not running with a clean
# environment, so that they are based on the temporary $HOME above.
# Otherwise, some tests would try to write to the user's real XDG_DATA_HOME,
# causing unwanted side-effects or FTBFS depending whether the user's
# real HOME is available in the build chroot (if used)
unexport XDG_CACHE_HOME
unexport XDG_CONFIG_DIRS
unexport XDG_CONFIG_HOME
unexport XDG_DATA_HOME
unexport XDG_DATA_DIRS

# Make sure that everything that uses D-Bus is creating its own temporary
# session rather than polluting the developer's (or failing, on buildds)
export DBUS_SESSION_BUS_ADDRESS=this-should-not-be-used-and-will-fail:

ifeq ($(DEB_HOST_ARCH_OS), linux)
handle_test_failure := exit $$?
else
handle_test_failure := true
endif

# Upstream test timeouts assume an otherwise unloaded system, but that
# isn't necessarily the case for a porterbox or multiple parallel builds
test_timeout_multiplier = 3

ifneq ($(filter arm hppa mips% sparc%,$(DEB_HOST_ARCH_CPU)),)
$(info Slow architecture detected, increasing test timeout)
test_timeout_multiplier = 5
endif

ifneq ($(filter m68k riscv64 sh4,$(DEB_HOST_ARCH_CPU)),)
$(info Architecture with qemu buildds detected, increasing test timeout a lot)
test_timeout_multiplier = 20
endif

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Remove LD_PRELOAD so we don't run with fakeroot, which makes dbus-related tests fail
	# First run the non-flaky tests, and fail the build if they fail (on linux)
	env -u LD_PRELOAD \
		DEB_BUILD_TIME_TESTS=1 \
		LC_ALL=C.UTF-8 \
		MESON_TESTTHREADS=1 \
	meson test -C debian/build/deb \
		--no-rebuild \
		--num-processes 1 \
		--timeout-multiplier $(test_timeout_multiplier) \
		--no-suite flaky \
		--verbose \
	|| $(handle_test_failure)
	# and then run the flaky ones, but ignore them failing
	env -u LD_PRELOAD \
		DEB_BUILD_TIME_TESTS=1 \
		LC_ALL=C.UTF-8 \
		MESON_TESTTHREADS=1 \
	meson test -C debian/build/deb \
		--no-rebuild \
		--num-processes 1 \
		--timeout-multiplier $(test_timeout_multiplier) \
		--suite flaky \
		--verbose \
	|| true
endif

# Skip build-time tests if all we are building is documentation; running
# them once per architecture is plenty
override_dh_auto_test-indep:
	@:

# The tests assume this directory exists and is writable
export XDG_RUNTIME_DIR=$(CURDIR)/debian/tmp-xdg-runtime-dir
# Let's get failing tests' stdout and stderr so we have some information when
# a build fails
export VERBOSE=1

ifeq ($(DEB_HOST_ARCH_OS),linux)
is_linux := true
enable_selinux := enabled
else
is_linux := false
enable_selinux := disabled
endif

ifneq ($(filter hurd kfreebsd,$(DEB_HOST_ARCH_OS)),)
use_fam := true
else
use_fam := false
endif

# configure flags
DEB_CONFIGURE_EXTRA_FLAGS := \
	-Dinternal_pcre=false \
	$(NULL)

DEB_CONFIGURE_FLAGS_deb := \
	--default-library both \
	-Dfam=$(use_fam) \
	-Dinstalled_tests=true \
	-Dlibmount=$(is_linux) \
	-Dman=true \
	-Dselinux=$(enable_selinux) \
	-Dsystemtap=true \
	-Dxattr=$(have_non_stub_xattr) \
	$(NULL)

ifneq ($(filter libglib2.0-doc,$(binaries)),)
DEB_CONFIGURE_FLAGS_deb += -Dgtk_doc=true
else
DEB_CONFIGURE_FLAGS_deb += -Dgtk_doc=false
endif

DEB_CONFIGURE_FLAGS_udeb := \
	--default-library shared \
	-Dgtk_doc=false \
	-Dinstalled_tests=false \
	-Dlibmount=false \
	-Dselinux=disabled \
	-Dxattr=$(have_non_stub_xattr) \
	$(NULL)

override_dh_auto_build:
	mkdir -p debian/tmp-xdg-runtime-dir
	dh_auto_build --builddirectory=debian/build/deb
ifneq ($(filter %-udeb,$(binaries)),)
	dh_auto_build --builddirectory=debian/build/udeb
endif

override_dh_auto_install:
	set -e; for script in postinst postrm triggers; do \
		sed -e"s/#MULTIARCH#/$(DEB_HOST_MULTIARCH)/g" \
		    -e"s/#ARCH#/$(DEB_HOST_ARCH)/g" \
		    debian/libglib2.0-0.$$script.in \
		    > debian/libglib2.0-0.$$script ; \
	done
ifneq ($(filter %-udeb,$(binaries)),)
	dh_auto_install -plibglib2.0-udeb --builddirectory=debian/build/udeb --destdir=debian/install/udeb
endif
	dh_auto_install --remaining-packages --builddirectory=debian/build/deb --destdir=debian/install/deb

override_dh_python3:
	# dh_python3 can't process both a private directory and /usr/bin
	# in the same invocation
	dh_python3 -plibglib2.0-dev-bin /usr/share/glib-2.0/codegen
	dh_python3 -plibglib2.0-tests --no-ext-rename /usr/libexec/installed-tests/glib
	dh_python3

override_dh_install:
	# Unwanted bits from the .deb build
	rm -fr debian/install/deb/usr/share/glib-2.0/codegen/__pycache__
ifneq ($(filter %-udeb,$(binaries)),)
	# Unwanted bits from the .udeb build
	rm -f debian/install/udeb/usr/lib/*/*.so
	rm -fr debian/install/udeb/usr/share/gdb
	rm -fr debian/install/udeb/usr/share/gettext/its
	rm -fr debian/install/udeb/usr/share/glib-2.0/codegen
	rm -fr debian/install/udeb/usr/share/glib-2.0/gdb
	rm -fr debian/install/udeb/usr/share/glib-2.0/valgrind
	rm -fr debian/install/udeb/usr/share/man
	dh_install -plibglib2.0-udeb --sourcedir=debian/install/udeb
endif
	dh_install --remaining-packages --sourcedir=debian/install/deb

override_dh_dwz:
	dh_dwz -Nlibglib2.0-udeb

override_dh_missing:
	dh_missing --sourcedir=debian/install/deb --fail-missing
ifneq ($(filter %-udeb,$(binaries)),)
	dh_missing --sourcedir=debian/install/udeb --fail-missing
endif

## glib2.0 2.64.1

=== debian/changelog ===
glib2.0 (2.64.1-1) unstable; urgency=medium

  * Team upload
  * New upstream stable release
  * d/p/tests-Skip-MemoryMonitor-test-if-GObject-Introspection-is.patch:
    Drop patch, applied upstream
  * Add Breaks on glib-networking-tests older than 2.63.2.
    Those versions had a test that relied on TLS version fallback
    behaviour that has now been removed. (Closes: #953766)

 -- Simon McVittie <smcv@debian.org>  Sun, 15 Mar 2020 18:39:17 +0000

glib2.0 (2.64.0-2) unstable; urgency=medium

  * Team upload
  * Merge packaging changes from unstable with new upstream release from
    experimental
  * d/control.in: Add Breaks on libgladeui-2-6 before 3.22.2.
    Older versions used a syntactically invalid property name
    "support warning", which GObject used to canonicalize to
    "support-warning". GLib 2.64 made this check more strict (see #953010).

 -- Simon McVittie <smcv@debian.org>  Tue, 10 Mar 2020 21:22:18 +0000

glib2.0 (2.64.0-1) experimental; urgency=medium

  * Team upload
  * New upstream release
    - Fixes a vulnerability where GSocketClient sometimes forgot to use
      a configured proxy (CVE-2020-6750, Closes: #948554)
    - Stop installing gio-launch-desktop, which no longer exists
    - d/p/docs-Don-t-install-object-manager-example-separately.patch:
      Drop, applied upstream
  * d/p/debian/testfilemonitor-Skip-if-we-are-avoiding-flaky-tests.patch:
    Treat testfilemonitor as a flaky test
  * Standards-Version: 4.5.0 (no changes required)
  * New upstream release
  * d/p/tests-Skip-MemoryMonitor-test-if-GObject-Introspection-is.patch:
    Skip MemoryMonitor test if GObject-Introspection is too old to know it
  * Install a shell script implementation of the old gio-launch-desktop
    executable. While not required for *this* GLib, it is required by
    old processes that already had the old GLib (2.57.2 to 2.63.5) in
    memory before the upgrade. This can be removed after Ubuntu 20.04
    and Debian 11 are both released.

 -- Simon McVittie <smcv@debian.org>  Fri, 28 Feb 2020 17:16:04 +0000

glib2.0 (2.63.5-2) experimental; urgency=medium

  * Skip-unreliable-gdbus-threading-tests--by-default.patch: Skip all of
    gdbus-threading test_method_calls_in_thread() has become (more?)
    unreliable too. When skipped, the test bus doesn't get torn down properly
    - it times out. Let's stop running these tests for now, until they are
    made reliable.

 -- Iain Lane <laney@debian.org>  Wed, 19 Feb 2020 17:16:16 +0000

glib2.0 (2.63.5-1) experimental; urgency=medium

  [ Iain Lane ]
  * New upstream release

  [ Philip Withnall ]
  * Rework 01_gettext-desktopfiles.patch to not add new public API.
    Downstreams should not be adding new public API to GLib. From some code
    searching, this doesn’t appear to be used in more than one or two places,
    so won’t be too inconvenient to drop.  The original patch should either be
    upstreamed (I’d be open to some form of it, if there’s still evidence it’s
    useful) or dropped. If it’s upstreamed, the new keys should be
    standardised.  The alternative to this was to document the added public
    API; its addition was causing the new gtk-doc tests in GLib to fail.
  * Bump gtk-doc-tools dependency to >= 1.32-4 as GLib requires some fixes
    pushed to gtk-doc after its 1.32 release.
  * control: Bump Meson dependency to >= 0.52.0 for building the documentation
  * Drop PKCS#11 APIs added in 2.63.1 (not stable yet)
      - g_tls_certificate_new_from_pkcs11_uris()
  * Remove patches applied upstream:
    - tests-Skip-GMemoryMonitor-tests-if-the-dbusmock-template-.patch
    - tests-optional-portal.patch
  * d/p/docs-Don-t-install-object-manager-example-separately.patch: Add patch
    from upstream to disable incorrect installation of some example
    documentation
  * Rework libmount Meson argument as it’s now a feature; see !1344 upstream

 -- Iain Lane <laney@debian.org>  Mon, 17 Feb 2020 17:47:17 +0000

glib2.0 (2.63.3-3) experimental; urgency=medium

  * debian/control.in:
    - lower the libglib2.0-tests Depends on xdg-desktop-portal to a
      Recommends since the portal is not available on some architectures
  * debian/patches/tests-optional-portal.patch:
    - skip the new memory monitor tests if the portal is not available,
      that allows the tests to be still successful on architectures were
      the portal is not available (e.g Ubuntu/i386)

 -- Sebastien Bacher <seb128@ubuntu.com>  Wed, 22 Jan 2020 09:36:27 +0200

glib2.0 (2.63.3-2) experimental; urgency=medium

  * debian/control.in:
    - libglib2.0-tests Depends on xdg-desktop-portal, it's required by the
      new low memory tests (and got enabled by the new python-dbusmock)

 -- Sebastien Bacher <seb128@ubuntu.com>  Thu, 16 Jan 2020 10:28:46 +0100

glib2.0 (2.63.3-1) experimental; urgency=medium

  [ Iain Lane ]
  * New upstream release
    + Add a `--glib-min-version` argument to `gdbus-codegen` which controls
      breaks in the API of generated code
    + Add `g_clear_list()` API to clear `GList`s to `NULL`
    + Add a `GMemoryMonitor` API to be notified of memory pressure situations
      using the low-memory-monitor project
    + Add support for dispose functions for `GSource` implementations
    + Tighten up validation of GObject signal and property names, allowing
      performance improvements
  * debian/tests/build: Style fixes, thanks to shellcheck.
  * d/p/d/Disable-some-tests-on-slow-architectures-which-keep-faili.patch:
    Rebase. Upstream have disabled these tests by default too (unless slow
    mode is enabled), so we don't need to add a patch to do a similar thing.
  * debian/libglib2.0-0.symbols: New symbols for 2.63.3
  * d/p/tests-Skip-GMemoryMonitor-tests-if-the-dbusmock-template-.patch: Add.
    We don't have a new enough dbusmock in Debian at the minute (one is not
    released yet). Skip the test if the required template isn't available.
  * control: Add Depends for the new memory-monitor tests.


=== debian/control ===
--- 
+++ 
@@ -17,17 +17,17 @@
                dpkg-dev (>= 1.17.14),
                gettext,
                gnome-pkg-tools (>= 0.11),
-               gtk-doc-tools (>= 1.20),
+               gtk-doc-tools (>= 1.32-4~),
                libdbus-1-dev (>= 1.2.14) <!nocheck> <!noinsttest>,
                libelf-dev (>= 0.142),
-               libffi-dev (>= 3.0.0),
+               libffi-dev (>= 3.3),
                libgamin-dev [!linux-any] | libfam-dev [!linux-any],
                libmount-dev (>= 2.28) [linux-any],
                libpcre3-dev (>= 1:8.35),
                libselinux1-dev [linux-any],
                libxml2-utils,
                linux-libc-dev [linux-any],
-               meson (>= 0.48.0),
+               meson (>= 0.52.0),
                pkg-config (>= 0.16.0),
                python3-dbus <!nocheck>,
                python3-distutils,
@@ -39,7 +39,7 @@
                xterm <!nocheck>,
                zlib1g-dev
 Rules-Requires-Root: no
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: http://www.gtk.org/
 Vcs-Browser: https://salsa.debian.org/gnome-team/glib
 Vcs-Git: https://salsa.debian.org/gnome-team/glib.git
@@ -51,6 +51,9 @@
 Recommends: libglib2.0-data,
             shared-mime-info,
             xdg-user-dirs
+Breaks: glib-networking-tests (<< 2.63.2),
+        libgirepository-1.0-1 (<< 1.62.0-4~),
+        libgladeui-2-6 (<< 3.22.2)
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Description: GLib library of C routines
@@ -63,11 +66,16 @@
 Package: libglib2.0-tests
 Build-profiles: <!noinsttest>
 Architecture: any
-Depends: libglib2.0-dev-bin,
+Depends: gir1.2-glib-2.0,
+         libglib2.0-dev-bin,
+         python3-dbus,
+         python3-dbusmock,
+         python3-gi,
          shared-mime-info,
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
+Recommends: xdg-desktop-portal,
 Pre-Depends: ${misc:Pre-Depends}
 Description: GLib library of C routines - installed tests
  GLib is a library containing many useful C routines for things such
@@ -115,7 +123,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libffi-dev (>= 3.0.0),
+Depends: libffi-dev (>= 3.3),
          libglib2.0-0 (= ${binary:Version}),
          libglib2.0-bin (= ${binary:Version}),
          libglib2.0-dev-bin (= ${binary:Version}),

## glib2.0 2.64.2

=== meson_options.txt ===
option('runtime_libdir',
       type : 'string',
       value : '',
       description : 'install runtime libraries relative to libdir')

option('iconv',
       type : 'combo',
       choices : ['auto', 'libc', 'external'],
       value : 'auto',
       description : 'iconv implementation to use (\'libc\' = \'Part of the C library\'; \'external\' = \'External libiconv\'; \'auto\' = \'Auto-detect which iconv is available\')')

option('charsetalias_dir',
       type : 'string',
       value : '',
       description : 'directory for charset.alias dir (default to \'libdir\' if unset)')

option('gio_module_dir',
       type : 'string',
       value : '',
       description : 'load gio modules from this directory (default to \'libdir/gio/modules\' if unset)')

option('selinux',
       type : 'feature',
       value : 'auto',
       description : 'build with selinux support')

option('xattr',
       type : 'boolean',
       value : true,
       description : 'build with xattr support')

option('libmount',
       type : 'feature',
       value : 'auto',
       description : 'build with libmount support')

option('internal_pcre',
       type : 'boolean',
       value : false,
       description : 'whether to use internal PCRE')

option('man',
       type : 'boolean',
       value : false,
       description : 'generate man pages (requires xsltproc)')

option('dtrace',
       type : 'boolean',
       value : false,
       description : 'include tracing support for dtrace')

option('systemtap',
       type : 'boolean',
       value : false,
       description : 'include tracing support for systemtap')

option('tapset_install_dir',
       type : 'string',
       value : '',
       description : 'path where systemtap tapsets are installed')

option('gtk_doc',
       type : 'boolean',
       value : false,
       description : 'use gtk-doc to build documentation')

option('bsymbolic_functions',
       type : 'boolean',
       value : true,
       description : 'link with -Bsymbolic-functions if supported')

option('force_posix_threads',
       type : 'boolean',
       value : false,
       description : 'Also use posix threads in case the platform defaults to another implementation (on Windows for example)')

option('fam',
       type : 'boolean',
       value : false,
       description : 'Use fam for file system monitoring')

option('installed_tests',
       type : 'boolean',
       value : false,
       description : 'enable installed tests')

option('nls',
       type : 'feature',
       value : 'auto',
       yield: true,
       description : 'Enable native language support (translations)')

option('oss_fuzz',
       type : 'feature',
       value : 'disabled',
       description : 'Indicate oss-fuzz build environment')

=== debian/changelog ===
glib2.0 (2.64.2-1~fakesync1) focal; urgency=medium

  [ Simon McVittie ]
  * Add Breaks on older versions of gimp, which used a syntactically
    invalid property name in a plugin, and would crash when GObject
    rejects syntactically invalid property names

  [ Sebastien Bacher ]
  * New upstream release
  * debian/patches/git_gsource_segfault.patch:
    - backport an upstream git change to fix a signal handler disconnect
      segfault situation (lp: #1872153)

 -- Sebastien Bacher <seb128@ubuntu.com>  Wed, 15 Apr 2020 23:01:50 +0200

=== debian/control ===
--- 
+++ 
@@ -51,7 +51,8 @@
 Recommends: libglib2.0-data,
             shared-mime-info,
             xdg-user-dirs
-Breaks: glib-networking-tests (<< 2.63.2),
+Breaks: gimp (<< 2.10.14-3~),
+        glib-networking-tests (<< 2.63.2),
         libgirepository-1.0-1 (<< 1.62.0-4~),
         libgladeui-2-6 (<< 3.22.2)
 Multi-Arch: same

=== debian/rules ===
--- 
+++ 
@@ -165,10 +165,10 @@
 export VERBOSE=1
 
 ifeq ($(DEB_HOST_ARCH_OS),linux)
-is_linux := true
+enable_libmount := enabled
 enable_selinux := enabled
 else
-is_linux := false
+enable_libmount := disabled
 enable_selinux := disabled
 endif
 
@@ -187,7 +187,7 @@
 	--default-library both \
 	-Dfam=$(use_fam) \
 	-Dinstalled_tests=true \
-	-Dlibmount=$(is_linux) \
+	-Dlibmount=$(enable_libmount) \
 	-Dman=true \
 	-Dselinux=$(enable_selinux) \
 	-Dsystemtap=true \
@@ -204,7 +204,7 @@
 	--default-library shared \
 	-Dgtk_doc=false \
 	-Dinstalled_tests=false \
-	-Dlibmount=false \
+	-Dlibmount=disabled \
 	-Dselinux=disabled \
 	-Dxattr=$(have_non_stub_xattr) \
 	$(NULL)
@@ -250,6 +250,7 @@
 	dh_install -plibglib2.0-udeb --sourcedir=debian/install/udeb
 endif
 	dh_install --remaining-packages --sourcedir=debian/install/deb
+	install -D -t debian/libglib2.0-0/usr/lib/${DEB_HOST_MULTIARCH}/glib-2.0/ debian/gio-launch-desktop
 
 override_dh_dwz:
 	dh_dwz -Nlibglib2.0-udeb

=== debian/tests/control ===
Tests: build build-static
Depends: libglib2.0-dev, build-essential
Restrictions: allow-stderr superficial

Tests: installed-tests
Depends: libglib2.0-tests, dbus-x11, dbus (>= 1.8), xauth, xvfb, gnome-desktop-testing
Restrictions: allow-stderr

Tests: flaky
Depends: libglib2.0-tests, dbus-x11, dbus (>= 1.8), xauth, xvfb, gnome-desktop-testing
Restrictions: allow-stderr flaky

=== debian/watch ===
version=4
https://download.gnome.org/sources/glib/([\d\.]+[02468])/ \
	glib@ANY_VERSION@\.tar\.xz
